#this import statement allows access to the karamba functions
import karamba
import os
import string

stop_bt=0
prev_bt = 0
play_bt = 0
next_bt = 0
prev_is_over = False
next_is_over = False
play_is_over = False
stop_is_over = False
#cover_img = 0
song_txt = 0
song_position = 0
current_play_bt = ""

#this is called when you widget is initialized
def initWidget(widget):
	global prev_bt, play_bt, next_bt, cover_img, song_txt, song_position, current_play_bt, stop_bt
#	karamba.createImage(widget, 0, 0, "images/background2.png")
	karamba.createImage(widget, 18, 19, "images/.png")
	prev_bt = karamba.createImage(widget,111, 4, "images/rw_.png")
	karamba.createClickArea(widget, 111, 4, 20, 20, "dcop amarok player prev")
	stop_bt = karamba.createImage(widget,151, 4, "images/stop_.png")
	karamba.createClickArea(widget, 151, 4, 20, 20, "dcop amarok player stop")	
	play_bt = karamba.createImage(widget, 131, 4, "images/play_.png")
	karamba.createClickArea(widget, 131, 4, 20, 20, "dcop amarok player playPause")
	next_bt = karamba.createImage(widget, 170, 4, "images/fw_.png")
	karamba.createClickArea(widget, 171, 4, 20, 20, "dcop amarok player next")
	song_txt = karamba.createText(widget, 11, 8, 90, 14, "title")
	karamba.setTextAlign(widget, song_txt, "LEFT")
	karamba.changeTextColor(widget, song_txt, 255, 255, 255)
	karamba.changeTextFont(widget, song_txt, "verdana")
	karamba.changeTextShadow(widget, song_txt, 0)
	karamba.changeTextSize(widget, song_txt, 9)
	karamba.createImage(widget, 147, 50, "images/progress_bar_background.png")
	song_position = karamba.createBar(widget, 271, 22, 43, 5, "images/progress_bar.png")
	karamba.setBarMinMax(widget, song_position, 0, 100)
	is_playing = str(os.popen("dcop amarok player status").readline())[0:-1]
	if (is_playing > "0"):
		song_title = str(os.popen("dcop amarok player title").readline())[0:-1]
		song_artist = str(os.popen("dcop amarok player artist").readline())[0:-1]
		song_cover = str(os.popen("dcop amarok player coverImage").readline())[0:-1]
		song_curpos = str(os.popen("dcop amarok player trackCurrentTime").readline())[0:-1]
		song_fullpos = str(os.popen("dcop amarok player trackTotalTime").readline())[0:-1]
		song_name = song_title + " - " + song_artist
		if (song_fullpos > "0"):
			song_pos = (long(song_curpos) * 100) / long(song_fullpos)
	else:
		song_name = "AmaroK Off"
		song_pos = 0
	if (is_playing == "2"):
                karamba.setImagePath(widget, play_bt, "images/pause_.png")
		current_play_bt = "pause"
	else:
                karamba.setImagePath(widget, play_bt, "images/play_.png")
		current_play_bt = "play"
	karamba.changeText(widget, song_txt, song_name)
	karamba.setBarValue(widget, song_position, song_pos)
	karamba.redrawWidget(widget)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	global  song_txt, song_position, current_play_bt
	is_playing = str(os.popen("dcop amarok player status").readline())[0:-1]
	if (is_playing > "0"):
		song_title = str(os.popen("dcop amarok player title").readline())[0:-1]
		song_artist = str(os.popen("dcop amarok player artist").readline())[0:-1]
		song_cover = str(os.popen("dcop amarok player coverImage").readline())[0:-1]
		song_curpos = str(os.popen("dcop amarok player trackCurrentTime").readline())[0:-1]
		song_fullpos = str(os.popen("dcop amarok player trackTotalTime").readline())[0:-1]
		song_name = song_title + " - " + song_artist
		if (song_fullpos > "0"):
			song_pos = (long(song_curpos) * 100) / long(song_fullpos)
	else:
		song_name = " Amarok Player"
		karamba.setImagePath(widget, cover_img, "")
		song_pos = 0
	if (is_playing == "2"):
                karamba.setImagePath(widget, play_bt, "images/pause_.png")
		current_play_bt = "pause"
	else:
                karamba.setImagePath(widget, play_bt, "images/play_.png")
		current_play_bt = "play"
	karamba.changeText(widget, song_txt, song_name)
	karamba.setBarValue(widget, song_position, song_pos)
	karamba.redrawWidget(widget)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#Warning:  Don't do anything too intensive here
#You don't want to run some complex piece of code everytime the mouse moves
def widgetMouseMoved(widget, x, y, button):
	global prev_bt, play_bt, next_bt, current_play_bt, prev_is_over, next_is_over, play_is_over, stop_bt, stop_is_over
	if (button == 0):
		if (x > 111 and x < 111 + 23 and y > 4 and y < 4+23):
			if (not prev_is_over):
				karamba.setImagePath(widget, prev_bt, "images/rw.png")
				prev_is_over = True
				karamba.redrawWidget(widget)				
		elif (x > 171 and x < 171 + 23 and y > 4 and y < 20+23):
			if (not next_is_over):
				karamba.setImagePath(widget, next_bt, "images/fw.png")
				next_is_over = True
				karamba.redrawWidget(widget)
		elif (x > 131 and x < 131 + 23 and y > 4 and y < 4+23):
			if (not play_is_over):
				karamba.setImagePath(widget, play_bt, "images/" + current_play_bt + ".png")
				play_is_over = True
				karamba.redrawWidget(widget)
		elif (x > 151 and x < 151 + 23 and y > 4 and y < 4+23):
			if (not stop_is_over):
				karamba.setImagePath(widget, stop_bt, "images/stop.png")
				stop_is_over = True
				karamba.redrawWidget(widget)
		else:
			if (prev_is_over):
				karamba.setImagePath(widget, prev_bt, "images/rw_.png")
				prev_is_over = False
				karamba.redrawWidget(widget)
			elif (next_is_over):
				karamba.setImagePath(widget, next_bt, "images/fw_.png")
				next_is_over = False
				karamba.redrawWidget(widget)
			elif (play_is_over):
				karamba.setImagePath(widget, play_bt, "images/" + current_play_bt + "_.png")
				play_is_over = False
				karamba.redrawWidget(widget)
			elif (stop_is_over):
				karamba.setImagePath(widget, stop_bt, "images/stop_.png")
				stop_is_over = False
				karamba.redrawWidget(widget)


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by tas13, 20kAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.  
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass
